/**********************************************
  e-Gizmo PBot Uno Controller - PBotAvoidCollision.ino

  This is for collsion sample sketch to avoid
  crashing on the wall or any objects that blocking
  way of the PBOT.

  Reading the 3channel Collision sensors:

  PBot.COL1_RIGHT();
  PBot.COL2_CENTER();
  PBot.COL3_LEFT();

  Output reads:
       No object detection = 0 or LOW;
       Object detected     = 1 or HIGH;

  Codes by
  e-Gizmo Mechatronix Central
  http://www.e-gizmo.net
  March 17,2020
************************************************/

#include "eGizmo_PBot_Uno.h"
#include <Wire.h>


eGizmo_PBot_Uno PBot;
int MotorSpeed = 80;
int TurnSpeed = 200;


void setup() {

  PBot.BEGIN();
}

void loop() {
  //TURN RIGHT
  if (PBot.COL2_CENTER() == HIGH && PBot.COL3_LEFT()) {

    PBot.REVERSE(TurnSpeed);
    delay(200);
    PBot.STOP();
    delay(1000);
    PBot.TURNRIGHT(TurnSpeed);
    delay(500);
  }

  if (PBot.COL2_CENTER() == LOW) {
    PBot.FORWARD(MotorSpeed);
  }
  //delay(200);
}